package com.zh.project0512.serviceImpl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.zh.project0512.controller.manage.StatisticsController;
import com.zh.project0512.model.Admin;
import com.zh.project0512.mapper.AdminMapper;
import com.zh.project0512.model.Video;
import com.zh.project0512.service.IAdminService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.DayOfWeek;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.time.temporal.ChronoUnit;
import java.time.temporal.TemporalAdjusters;
import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author zh
 * @since 2022-06-10
 */
@Service
public class AdminServiceImpl extends ServiceImpl<AdminMapper, Admin> implements IAdminService {
    @Autowired
    private AdminMapper adminMapper;
    public ArrayList videoData(StatisticsController.SSParam params){
        int condition = params.getDateCondition();
        QueryWrapper<Video> qw = new QueryWrapper<>();
        DateTimeFormatter df = DateTimeFormatter.ofPattern("yyyy-MM-dd");
        DateTimeFormatter df2 = DateTimeFormatter.ofPattern("yyyy-MM");
        LocalDate now = LocalDateTime.now().toLocalDate();
        LocalDate before = now.with(TemporalAdjusters.firstDayOfMonth());
        switch (condition) {
            case 1:
                before = now;
                break;
            case 2:
                before = now.with(DayOfWeek.MONDAY);
                break;
            case 3:
                before = now.with(TemporalAdjusters.firstDayOfMonth());
                break;
            case 4:
                before = now.with(TemporalAdjusters.firstDayOfYear());
                break;
            default:
                before = params.getBeginTime() != null ? params.getBeginTime().toLocalDate() : before;
                now = params.getEndTime() != null ? params.getEndTime().toLocalDate() : now;
        }
        if(params.getTaskId()>0){
            qw.eq("taskId", params.getTaskId());
        }
        if(params.getUserId()>0){
            qw.eq("userId", params.getUserId());
        }
        ArrayList<JSONObject> res = new ArrayList<>();
        if (4 == condition) {
            qw.between("date_format(creatAt, '%Y-%m')", before.format(df2), now.plusMonths(1).format(df2));
            List<JSONObject> videoDataBydDay = adminMapper.statistics3(qw);
            for (int i = 0; i <= ChronoUnit.MONTHS.between(before, now); i++) {
                LocalDate today = before.plusMonths(i);
                JSONObject obj = null;
//            Stream<JSONObject> dat1 = videoDataBydDay.stream().filter(x -> LocalDate.parse((CharSequence) x.get("dat"), df) == today);
                for (JSONObject o : videoDataBydDay) {
                    if (o.get("dat").equals(today.format(df2))) {
                        obj = o;
                        break;
                    }
                }
                res.add(obj == null ? new JSONObject().fluentPut("dat", today.format(df2)).fluentPut("playNumSum", 0).fluentPut("collectionNumSum", 0).fluentPut("reSendNumSum", 0)
                    .fluentPut("recommendNumSum", 0).fluentPut("commentNumSum", 0).fluentPut("commendNumSum", 0) : obj);
            }
        } else {
            qw.between("date_format(creatAt, '%Y-%m-%d')", before, now.plusDays(1));
            List<JSONObject> videoDataBydDay = adminMapper.statistics2(qw);
            for (int i = 0; i <= ChronoUnit.DAYS.between(before, now); i++) {
                LocalDate today = before.plusDays(i);
                JSONObject obj = null;
//            Stream<JSONObject> dat1 = videoDataBydDay.stream().filter(x -> LocalDate.parse((CharSequence) x.get("dat"), df) == today);
                for (JSONObject o : videoDataBydDay) {
                    if (LocalDate.parse((CharSequence) o.get("dat"), df).equals(today)) {
                        obj = o;
                        break;
                    }
                }
                res.add(obj == null ? new JSONObject().fluentPut("dat", today).fluentPut("playNumSum", 0).fluentPut("collectionNumSum", 0).fluentPut("reSendNumSum", 0)
                    .fluentPut("recommendNumSum", 0).fluentPut("commentNumSum", 0).fluentPut("commendNumSum", 0) : obj);
            }
        }
        return res;
    }
}
